/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.1 on 2010-01-12 18:00:50,
 any modifications will be overwritten.
 ==============================================================
 */

package org.apache.maven.archetype.catalog.io.xpp3;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.io.Writer;
import java.text.DateFormat;
import java.util.Iterator;
import java.util.Locale;
import org.apache.maven.archetype.catalog.Archetype;
import org.apache.maven.archetype.catalog.ArchetypeCatalog;
import org.codehaus.plexus.util.xml.pull.MXSerializer;
import org.codehaus.plexus.util.xml.pull.XmlSerializer;

/**
 * Class ArchetypeCatalogXpp3Writer.
 * 
 * @version $Revision$ $Date$
 */
@SuppressWarnings( "all" )
public class ArchetypeCatalogXpp3Writer
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field NAMESPACE.
     */
    private static final String NAMESPACE = null;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method write.
     * 
     * @param writer
     * @param archetypeCatalog
     * @throws java.io.IOException
     */
    public void write( Writer writer, ArchetypeCatalog archetypeCatalog )
        throws java.io.IOException
    {
        XmlSerializer serializer = new MXSerializer();
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-indentation", "  " );
        serializer.setProperty( "http://xmlpull.org/v1/doc/properties.html#serializer-line-separator", "\n" );
        serializer.setOutput( writer );
        serializer.startDocument( archetypeCatalog.getModelEncoding(), null );
        writeArchetypeCatalog( archetypeCatalog, "archetype-catalog", serializer );
        serializer.endDocument();
    } //-- void write( Writer, ArchetypeCatalog )

    /**
     * Method writeArchetype.
     * 
     * @param archetype
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeArchetype( Archetype archetype, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( archetype != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( archetype.getGroupId() != null )
            {
                serializer.startTag( NAMESPACE, "groupId" ).text( archetype.getGroupId() ).endTag( NAMESPACE, "groupId" );
            }
            if ( archetype.getArtifactId() != null )
            {
                serializer.startTag( NAMESPACE, "artifactId" ).text( archetype.getArtifactId() ).endTag( NAMESPACE, "artifactId" );
            }
            if ( archetype.getVersion() != null )
            {
                serializer.startTag( NAMESPACE, "version" ).text( archetype.getVersion() ).endTag( NAMESPACE, "version" );
            }
            if ( archetype.getRepository() != null )
            {
                serializer.startTag( NAMESPACE, "repository" ).text( archetype.getRepository() ).endTag( NAMESPACE, "repository" );
            }
            if ( archetype.getDescription() != null )
            {
                serializer.startTag( NAMESPACE, "description" ).text( archetype.getDescription() ).endTag( NAMESPACE, "description" );
            }
            if ( ( archetype.getGoals() != null ) && ( archetype.getGoals().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "goals" );
                for ( Iterator iter = archetype.getGoals().iterator(); iter.hasNext(); )
                {
                    String goal = (String) iter.next();
                    serializer.startTag( NAMESPACE, "goal" ).text( goal ).endTag( NAMESPACE, "goal" );
                }
                serializer.endTag( NAMESPACE, "goals" );
            }
            if ( ( archetype.getProperties() != null ) && ( archetype.getProperties().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "properties" );
                for ( Iterator iter = archetype.getProperties().keySet().iterator(); iter.hasNext(); )
                {
                    String key = (String) iter.next();
                    String value = (String) archetype.getProperties().get( key );
                    serializer.startTag( NAMESPACE, "" + key + "" ).text( value ).endTag( NAMESPACE, "" + key + "" );
                }
                serializer.endTag( NAMESPACE, "properties" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeArchetype( Archetype, String, XmlSerializer )

    /**
     * Method writeArchetypeCatalog.
     * 
     * @param archetypeCatalog
     * @param serializer
     * @param tagName
     * @throws java.io.IOException
     */
    private void writeArchetypeCatalog( ArchetypeCatalog archetypeCatalog, String tagName, XmlSerializer serializer )
        throws java.io.IOException
    {
        if ( archetypeCatalog != null )
        {
            serializer.startTag( NAMESPACE, tagName );
            if ( ( archetypeCatalog.getArchetypes() != null ) && ( archetypeCatalog.getArchetypes().size() > 0 ) )
            {
                serializer.startTag( NAMESPACE, "archetypes" );
                for ( Iterator iter = archetypeCatalog.getArchetypes().iterator(); iter.hasNext(); )
                {
                    Archetype o = (Archetype) iter.next();
                    writeArchetype( o, "archetype", serializer );
                }
                serializer.endTag( NAMESPACE, "archetypes" );
            }
            serializer.endTag( NAMESPACE, tagName );
        }
    } //-- void writeArchetypeCatalog( ArchetypeCatalog, String, XmlSerializer )

}
